package org.xbib.elx.http.action.admin.indices.flush;

import org.elasticsearch.action.admin.indices.flush.FlushAction;
import org.elasticsearch.action.admin.indices.flush.FlushRequest;
import org.elasticsearch.action.admin.indices.flush.FlushResponse;
import org.elasticsearch.common.CheckedFunction;
import org.elasticsearch.common.xcontent.XContentParser;
import org.xbib.elx.http.HttpAction;
import org.xbib.net.http.client.HttpResponse;
import org.xbib.net.http.client.netty.HttpRequestBuilder;

import java.io.IOException;

public class HttpFlushIndexAction extends HttpAction<FlushRequest, FlushResponse> {

    @Override
    public FlushAction getActionInstance() {
        return FlushAction.INSTANCE;
    }

    @Override
    protected HttpRequestBuilder createHttpRequest(String url, FlushRequest request) {
        String index = request.indices() != null ? String.join(",", request.indices()) + "/" : "";
        return newPostRequest(url, "/" + index + "_flush");
    }

    @Override
    protected CheckedFunction<XContentParser, FlushResponse, IOException> entityParser(HttpResponse httpResponse) {
        return FlushResponse::fromXContent;
    }
}
